#include "mymodel.h"

MyModel::MyModel(QObject *parent) :
      QSqlTableModel(parent)
{
    setEditStrategy(QSqlTableModel::OnManualSubmit);
}

Qt::ItemFlags MyModel::flags(
         const QModelIndex &index) const {
Qt::ItemFlags flags = QSqlTableModel::flags(index);

/***********************************************

if ((index.column() != 3) && (index.column() != 0))
     flags |= Qt::ItemIsEditable;
//if (index.column() == 4)
//     flags |= Qt::ItemIsUserCheckable;
else
{
    if ((index.column() == 3) || (index.column() == 0)) flags &= ~Qt::ItemIsEditable; //    
}

*************************************************/



return flags;
}


bool MyModel::setData(const QModelIndex &index, const QVariant &value, int role) {
  ////  if (index.column()==3) return false; //       
    bool lResult = false;

    /*
    QString str_tmp;
    if (index.column()==1) {                //    
        str_tmp = value.toString();         //     
        str_tmp.append(tr(" instance"));
      }
      */
/*
    QString str_tmp;
    if (index.column()==0) {                //    
        str_tmp = value.toString();         //     
        str_tmp.append(tr("_instance"));
      }
*/
    lResult = QSqlTableModel::setData(index, value, role);



 /*****************************************************8

    if (lResult) {
        QModelIndex newindex;
        QSqlRecord rec = record(index.row());

        rec.setValue(index.column(), value);
        rec.setGenerated(index.column(), true);



        lResult = updateRowInTable(index.row(), rec);
  ///      QSqlTableModel::setData(newindex, QVariant(str_tmp), Qt::EditRole);


    }
**********************************************/




    return lResult;





}



QVariant MyModel::data(const QModelIndex &index, int role) const {

     QVariant value = QSqlTableModel::data(index, role);
     QList <int> keys;
     QStringList values;
     keys = pointers_map.keys(); //    
     values = pointers_map.values(); //  -   

switch (role) {
        case Qt::DisplayRole:
            {
               int index_of_list;
               index_of_list = keys.indexOf(index.column());

               if (index_of_list == -1) return value;
               else {
                   QString parentInctance;
                   QSqlQuery q;
                   QString sql_str;
                   bool ok;
                   parentInctance = values.at(index_of_list);
                   sql_str = tr("select * from `");
                   sql_str.append(parentInctance);
                   sql_str.append(tr("` "));
                   sql_str.append(tr("where `ID` = "));
                   sql_str.append(value.toString());
                   q.prepare(sql_str);
                   ok = q.exec();

                   if (ok)  {
                                while(q.next()){
                                  QString object_name = q.value(1).toString();
                                  if (!object_name.isEmpty()) return object_name;

                                                  }
                            }
                   int ii;
                   ii++;


               }
               return value;

        }
         //   if (index.column() == 1)
          //     return value.toString().prepend(tr(" "));


        case Qt::EditRole:  return value;
           // if (index.column() == 1)
           //    return value.toString().prepend(tr(" "));

        case Qt::TextColorRole:
            if(index.column() == 1)
                return qVariantFromValue(QColor(Qt::blue));
            else
              return value;
        case Qt::TextAlignmentRole: return value;
        case Qt::FontRole:
           if(index.column() == 1) {
               QFont font = QFont("Helvetica", 16, QFont::Bold);
              return qVariantFromValue(font);
           }else
               return value;

       case Qt::BackgroundColorRole: {
                int a = (index.row() % 2) ? 14 : 0;
                if(index.column() == 2)
                           return qVariantFromValue(QColor(220,240-a,230-a));
                        else if(index.column() == 4)
                            return qVariantFromValue(QColor(200,220-a,255-a));
                        else
                           return value;
                                    }



     case Qt::CheckStateRole: return value;

     case Qt::SizeHintRole:return value;

       }
  return value;
}


